//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***

// $Header: fsfileisopen.c,r42 2006-02-18 04:23:47 ingo $


#include "fsyspriv.h"





// CHECK IF FILE IS OPEN, RETURNS TRUE/FALSE

int FSFileIsOpen(FS_FILE *file,FS_VOLUME *fs)
{
FS_FILE *ff;
int f;

for(f=0;f<FS_MAXOPENFILES;++f)
{
ff=fs->Files[f];
while(ff!=NULL) {
if(ff==file) return TRUE;
if(ff->Dir==file->Dir) {
if(ff->Name!=NULL && file->Name!=NULL && FSNameCompare(ff->Name,file->Name,FSystem.CaseMode)) return TRUE;
}

ff=ff->Dir;
} 
}

return FALSE;

}
