//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file as well as the entire HPG library was written by Chris Smith
//& for HPGCC 1.0, now maintained by the HPGCC3 team.
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



#include "hpgraphics.h"
#include "hpgpriv.h"

void hpg_fill_rect_on(hpg_t *g, int x1, int y1, int x2, int y2)
{
    hpg_init();
    if(g==NULL) g=HPG_STDSCREEN;
    if (x1 > x2)
    {
        int temp;

        temp = x1;
        x1 = x2;
        x2 = temp;
    }

    int y;
    for (y = y1; y <= y2; y++)
    {
        _hpg_draw(g, x1, y, x2 - x1 + 1, x1, y1);
    }
}
