//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***


#include <hpgcc3.h>

extern const unsigned short const __keyb_shiftconvert[8];


int keyb_getkey(int wait)
{
    
	// by Claudio
		
	    keymatrix m;
	    m=keyb_getmatrix();

	    if(wait) {
	        // wait for a non-shift key to be pressed
	        while( (m&0x8fffffffffffffffLL )==0LL ) m=keyb_getmatrix();
	    }

	    int kcode,shft=(m>>60)&0x7;
	    unsigned char *mbytes=(unsigned char *)&m;
	    int k;
	    for(k=0,kcode=0;k<8;++mbytes,++k,kcode+=8)
	    {
	        if(*mbytes!=0) {
	            k=*mbytes;
	            while( !(k&1) ) {
	                k>>=1;
	                ++kcode;
	                }
	        break;
	        }
	    }


	    if(wait) {
	        while( (m&0x8fffffffffffffffLL )!=0 ) m=keyb_getmatrix();
	    if(kcode>=60) kcode=63;
	    }
	    
	    if(kcode<60) return kcode | __keyb_shiftconvert[shft];
	    if(kcode<64) return kcode;
	    return 0;
	
}

