//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***

// $Header: fsclose.c,r42 2006-02-18 04:23:47 ingo $


#include "fsyspriv.h"





int FSClose(FS_FILE *file)
{
int f,error;
FS_VOLUME *fs;

if(!FSystem.Init) return FS_ERROR;

if(file==NULL) return FS_ERROR;

if(file->Volume&(~3)) return FS_ERROR;		// INVALID VOLUME --> FILE STRUCTURE CORRUPT
//printf("close buffers\n");
error=FSFlushBuffers(file);
if(error!=FS_OK) return error;


fs=FSystem.Volumes[file->Volume];
//printf("remove open list\n");
// REMOVE FROM OPEN FILE LIST
for(f=0;f<FS_MAXOPENFILES;++f)
{
if(fs->Files[f]==file) { fs->Files[f]=NULL; break; }
}
//printf("free structure\n");
if(!FSFileIsReferenced(file,fs)) // FREE ALLOCATED MEMORY
		while((file=FSFreeFile(file)));
//printf("done close\n");
return FS_OK;
}
