//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***

// $Header: fsfileisreferenced.c,r42 2006-02-18 04:23:47 ingo $


#include "fsyspriv.h"


// UPDATE ENTRY OFFSET IN ALL OPENFILES/DIRS WHILE REPACKING A DIRECTORY

void FSMovedOpenFiles(FS_FILE *dir,int entryoffset,int newoffset,FS_VOLUME *fs)
{
FS_FILE *ff;
int f;


ff=fs->CurrentDir;
while(ff!=NULL) {
if(ff->Dir==dir) {
if(ff->DirEntryOffset==entryoffset) ff->DirEntryOffset=newoffset;
}
ff=ff->Dir;
} 

for(f=0;f<FS_MAXOPENFILES;++f)
{
ff=fs->Files[f];
while(ff!=NULL) {
if(ff->Dir==dir) {
if(ff->DirEntryOffset==entryoffset) ff->DirEntryOffset=newoffset;
}
ff=ff->Dir;
} 
}

return;

}
