//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



static void __SVM_flush_Dcache(void) __attribute__ ((naked));
static void __SVM_flush_Dcache(void)
{
	register unsigned int counter asm("r2");
	register unsigned int cacheaddr asm("r3");
	
    asm volatile ("stmfd sp!, {r0-r3, r14}");
	

	counter=0;
	while(counter<512) {
	cacheaddr=((counter>>1)&0xe0) | ((counter&63)<<26);
    // CLEAN AND INVALIDATE ENTRY USING INDEX
    asm volatile ("mcr p15, 0, %0, c7, c14, 2" : : "r" (cacheaddr));

	++counter;
	}
    // next MVA
    asm volatile ("ldmfd sp!, {r0-r3, r14}" : : "r" (counter) ,"r" (cacheaddr));
    asm volatile ("movs pc, r14");
}

static void __SVM_flush_Icache(void) __attribute__ ((naked));
static void __SVM_flush_Icache(void)
{
    // CLEAN AND INVALIDATE ENTRY USING INDEX
	
	register unsigned int value;
	
	asm volatile ("str %0,[sp , #-4]!": "=r" (value));
	
	value=0;
    asm volatile ("mcr p15, 0, %0, c7, c5, 0" : : "r" (value));
	
	asm volatile("ldr %0,[sp],#4" : "=r" (value) );
    asm volatile ("movs pc, r14");
}

static void __SVM_flush_TLB(void) __attribute__ ((naked));
static void __SVM_flush_TLB(void)
{
    // CLEAN AND INVALIDATE ENTRY USING INDEX
	
	register unsigned int value;
	
	asm volatile ("str %0,[sp , #-4]!": "=r" (value));
	
	value=0;
    asm volatile ("mcr p15, 0, %0, c8, c7, 0" : : "r" (value));
	
	asm volatile("ldr %0,[sp],#4" : "=r" (value));
    asm volatile ("movs pc, r14");
}

void __go_supervisor(unsigned int funcarg,unsigned int __funcaddr,unsigned int SWI_vector)
{
	register unsigned int original_value = *(unsigned int *)SWI_vector;
	
	*((unsigned int *)SWI_vector)=__funcaddr;
	
    asm volatile ("add lr, pc, #0" : : : "lr");
    asm volatile ("swi #0" : : : "r0","r1","r2","r3","ip","memory");

    *((unsigned int *)SWI_vector)=original_value;
    
}

void __launch_flush_cache()
{

__go_supervisor(0,(unsigned int) &__SVM_flush_Dcache,0x08000008);

__go_supervisor(0,(unsigned int) &__SVM_flush_Icache,0x08000008);

__go_supervisor(0,(unsigned int) &__SVM_flush_TLB,0x08000008);

}
